<cfinclude template="includes/imports.cfm">
<cfinclude template="../Includes/imports.cfm">
<cfimport taglib="../cfcustomtags/devtools" prefix="devtools">

<cfparam name="url.formID" type="numeric" default="0">
<cfparam name="url.viewType" type="numeric" default="1">

<cfset sOrderBy = "ResponseNumber DESC">
<cfif IsDefined("url.sort")>
	<cfset sOrderBy = url.sort>
</cfif>
<cfif IsDefined("url.order")>
	<cfswitch expression="#url.order#">
		<cfcase value="1">
			<cfset graphic = "asc.gif">
			<cfset graphicAlt = "Ascending">
		</cfcase>
		<cfcase value="0">
			<cfset sOrderBy &= " DESC">
			<cfset graphic = "desc.gif">
			<cfset graphicAlt = "Descending">
		</cfcase>
		<cfdefaultcase>
			<cfset graphic="../graphics/Administrator/spacer.gif">
			<cfset graphicAlt = "">
		</cfdefaultcase>
	</cfswitch>
</cfif>

<cfquery name="qryLayout" datasource="#application.config.DSN#">
	SELECT		ShowBorder, ColumnWidthType, SystemField, FieldID, FieldRow, FieldColumn, SortOrder, HideLabel,
				ColumnWidthPixel, ColumnWidthPercent, ShowLinkAsIcon, ShowLabelLinkOnly, ShowTime, c.UnitSystem,
				c.FieldTypeID, c.FieldLabel, c.FieldName, d.FieldName AS SystemFieldLabel, d.DbName AS SystemFieldName,
				c.DateType
	FROM		FormListingLayout a 
					INNER JOIN FormLayoutField b ON a.LayoutID = b.LayoutID
					LEFT JOIN FormField c ON b.FieldID = c.FormFieldID AND b.SystemField = 0
					LEFT JOIN FormSystemField d ON b.FieldID = d.FieldTypeID AND b.SystemField = 1
	WHERE		a.FormID = <cfqueryparam value="#url.formID#" cfsqltype="cf_sql_integer">
					AND a.LayoutPageID = 2
	ORDER BY	b.FieldRow, b.FieldColumn, b.SortOrder
</cfquery>

<!--- get form data --->
<cfset eform = cfcForm.read(nFormID = url.formID, bMetaOnly = true)>

<!--- get form permissions --->
<cfset oPerm = cfcForm.getFormPermission(nFormID = url.formID, nUserID = session.user.userID)>
	
<cfif oPerm.bView>
	
	<!--- update persisted search form state --->
	<cfif IsDefined("url.viewall")>
		<cfset session.fb = StructNew()>
		<cfset session.fb.formID = url.formID>
		<cfset session.fb.searchForm = StructNew()>
	<cfelseif NOT IsDefined("session.fb")
		OR session.fb.formID NEQ url.formID
		OR (cgi.REQUEST_METHOD EQ "post" AND FindNoCase("search_responses.cfm", cgi.HTTP_REFERER))>
		<cfset session.fb = StructNew()>
		<cfset session.fb.formID = url.formID>
		<cfset session.fb.searchForm = Duplicate(form)>
	</cfif>
	
	<!--- get responses --->
	<cfset isSearch = false>
	<cfif NOT IsDefined("url.viewType") OR url.viewType EQ 1>
		<!--- table view can use pagination --->
		<cfquery name="qryDynamicColumns" dbtype="query">
			SELECT		FieldName
			FROM		qryLayout
			WHERE		SystemField = 0
						AND FieldName IS NOT NULL
		</cfquery>
		<cfset sColumnList = ValueList(qryDynamicColumns.FieldName)>
		<cfset bPagination = eform.pagination>
		<cfset bPaginationInit = 0>
		<cfif IsDefined("url.pagerecords") AND IsNumeric(url.pagerecords) AND url.pagerecords GT 0>
			<cfset nItemsPerPage = url.pagerecords>
		<cfelse>
			<cfset nItemsPerPage = IIf(IsNumeric(eform.PaginationItemsPerPage), "eform.PaginationItemsPerPage", "0")>
		</cfif>
		<cfset nPaginationType = IIf(IsNumeric(eform.paginationType), "eform.paginationType", "0")>
		<cfset nPaginationLocation = IIf(IsNumeric(eform.paginationLocation), "eform.paginationLocation", "0")>
		<cfset nPageDisplay = 5>
		<cfset nPageIdx = IIf(IsDefined("url.pageidx"), "url.pageidx", "1")>
		<cfset oResponses = cfcFormResponse.getSearchResults(nFormID = url.formID, nUserID = session.user.userID, oForm = session.fb.searchForm, sColumnList = sColumnList, sOrderBy = sOrderBy, bPagination = bPagination, nPageDisplay = nItemsPerPage, nPageIdx = nPageIdx)>
		<cfset isSearch = true>
	<cfelse>
		<!--- summary view is always based on all results --->
		<cfset oResponses = cfcFormResponse.getSearchResults(nFormID = url.formID, nUserID = session.user.userID, oForm = session.fb.searchForm, sColumnList = 'NULL', sOrderBy = sOrderBy, summaryView = true)>
	</cfif>
	<cfset qryResponseView = oResponses.qryResponses>

	<cfoutput>
		<devtools:site_header>
			<!--- form control resources --->
			<devtools:control_date DumpResources="true" />
			<devtools:control_time DumpResources="true" />
			<devtools:control_textarea DumpResources="true" />
			
			<!--- css rules for view --->
			<cfinclude template="includes/css/form_views.cfm">
						
			<!--- jQuery templates for build & form view --->
			<cfinclude template="includes/js/form_templates.cfm">
			
			<!--- include models & view js --->
			<script src="#session.sWebRoot#/Lib/backbone/models/form.js?version=#application.cache.qryAdminInfo.Version#"></script>
			<script src="#session.sWebRoot#/Forms/includes/js/views/form_view.js?version=#application.cache.qryAdminInfo.Version#"></script>
			<script src="#session.sWebRoot#/Forms/includes/js/views/form_summary_view.js?version=#application.cache.qryAdminInfo.Version#"></script>
		
			<script type="text/javascript">
				$(document).ready(function(){
					$('a.columnHeader').click(function(){
						location.href = 'search_response_results.cfm?formID=#url.formID#&sort=' + $(this).prop("name") + '&order=<cfif isDefined("url.order") AND url.order EQ 1>0<cfelse>1</cfif>';
					});
					
					$('a.responseLink').click(function(){
						location.href = $('##frmResponses').attr('action') + '&responseID=' + $(this).data('formresponseid');
					});
					
					$('a.clearFilter').click(function(){
						location.href = 'search_response_results.cfm?formID=#url.formID#&viewall=true';
					});
					
					$('a.searchForm').click(function(){
						location.href = 'search_responses.cfm?formID=#url.formID#';
					});
					
					$('a.goBack').click(function(){
						history.go(-1);
					});
					
					$('.exportCSV').css({
							cursor: 'pointer'
						})
						.click(function(){
							// get excel export of responses shown
							$('##bPagination').val('true');
							$('##frmExport').attr('action', 'response_csv.cfm').submit();
						})	
					;
					$('.exportCSVall').css({
							cursor: 'pointer'
						})
						.click(function(){
							// get excel export of all responses
							if (#IIf(IsDefined("qryResponseView.TotalResults"), "qryResponseView.TotalResults", "qryResponseView.RecordCount")# > 1000){
								alertDialog({
									title: "Export Confirmation",
									message: 'You are attempting to export more than 1,000 responses. Depending on your environment, number of fields in this form, and overall form data volume, this operation could affect server performance. You may want to consider doing this during non-peak hours. <br/><br/>Do you wish to continue?',
									width: 400,
									buttons: {
										"OK": function(){
											$('##bPagination').val('false');
											$('##frmExport').attr('action', 'response_csv.cfm').submit();
											$(this).dialog("close");
										},
										"Cancel": function(){
											$(this).dialog("close");
										}
									}
								});
							} else {
								$('##bPagination').val('false');
								$('##frmExport').attr('action', 'response_csv.cfm').submit();
							}
						})	
					;
					
					$('.deleteAll').click(function(){
						var msg = '';
						var which = '#IIf(isSearch, DE('search'), DE('all'))#'
						if ($('##deleteOptions').length) {
							msg = 'Please choose which responses you would like to delete.<br/><br/>';
							msg += $('##deleteOptions').html();
							msg += '<br/><br/>This process cannot be undone. Are you sure you want to continue?';
						} else {
							msg = 'This action will delete <b>ALL</b> responses to this form.<br/><br/>This process cannot be undone. Are you sure you want to continue?';
						}
						
						alertDialog({
							title: "Delete Confirmation",
							message: msg,
							width: 400,
							buttons: {
								"OK": function(){
									var cfcForm = new FormProxy();
									cfcForm.setHTTPMethod('post');
									var bSuccess = $.ic.fnAjaxProxy(cfcForm, 'deleteResponses', {
										nFormID: #url.formID#,
										sWhich: $(this).find('input[name="rd_deleteAll"]').length ? $(this).find('input[name="rd_deleteAll"]:checked').val() : which
									});
									if (bSuccess) {
										location.href = 'search_responses.cfm?formID=#url.formID#';
									}									
									$(this).dialog("close");
								},
								"Cancel": function(){
									$(this).dialog("close");
								}
							}
						});
					});
		
					$.ic.fnGoToResponse = function(){
						var responseNo = $.trim($('##txt_go_to').val());
						if (responseNo.length != 0 && responseNo.isNumber(3)) {
							location.href = 'viewform.cfm?formID=#url.formID#&responseNo=' + responseNo;
						} else {
							alertDialog({
								message: "You must enter a response submission number",
								focusObj: $('##txt_go_to')
							});
						}
						return false;
					}
					
					$('##btn_go_to').click(function(){
						return $.ic.fnGoToResponse();
					});
					$('##txt_go_to').keyup(function(e){
						if (e.keyCode == '13') {
							return $.ic.fnGoToResponse();
						}
					});
					
					$('a.deleteResponse').on('click', function(){
						var response = this;
						alertDialog({
							title: "Delete Confirmation",
							message: "You are about to <b>DELETE</b> this form response.<br/><br/>Do you wish to continue?",
							width: 400,
							buttons: {
								"OK": function(){
									var cfcFormResponse = new FormResponseProxy();
									cfcFormResponse.setHTTPMethod('post');
									$.ic.fnAjaxProxy(cfcFormResponse, 'deleteResponse', {
										nResponseID: $(response).data('responseid') 
									});
									$(response).closest('tr').remove();
									$(this).dialog("close");
								},
								"Cancel": function(){
									$(this).dialog("close");
								}
							}
						});
					});
				});
			</script>
		</devtools:site_header>
		
		<!--- form to export --->
		<form id="frmExport" method="post" target="_blank">
			<input type="hidden" id="formID" name="formID" value="#url.formID#" />
			<input type="hidden" id="sOrderBy" name="sOrderBy" value="#sOrderBy#" />
			<cfif IsDefined("bPagination") AND bPagination AND (NOT IsDefined("url.viewType") OR url.viewType EQ 1)>
				<input type="hidden" id="bPagination" name="bPagination" value="#bPagination#" />
				<input type="hidden" id="nItemsPerPage" name="nItemsPerPage" value="#nItemsPerPage#" />
				<input type="hidden" id="nPageIdx" name="nPageIdx" value="#nPageIdx#" />
			</cfif>
		</form>

		<div align="center">
			<table class="normalPadding headerBorder">
			<tr>
				<td width="65%" class="header"><a href="#session.sWebRoot#/Forms/viewform.cfm?formid=#url.formID#">#eform.title#</a></td>
				<td class="subHeader" style="text-align: right;" width="45%">
					<cfinclude template="includes/top_right_links.cfm">
				</td>
			</tr>
			<tr>
				<td colspan="2" class="content">
					<table class="lightPadding">
					<tr>
						<!--- switch view --->
						<td>
							<cfif url.viewType EQ 1>
								<a href="search_response_results.cfm?formID=#url.formID#&viewType=2">
									<img src="#session.sImageRoot#/Formbuilder/chart_view.png" style="vertical-align: middle; width: 16px;" /></a>
								<a href="search_response_results.cfm?formID=#url.formID#&viewType=2">Summary</a>
							<cfelse>
								<a href="search_response_results.cfm?formID=#url.formID#&viewType=1">
									<img src="#session.sImageRoot#/Formbuilder/table_view.png" style="vertical-align: middle; width: 16px;" /></a>
								<a href="search_response_results.cfm?formID=#url.formID#&viewType=1">Table</a>
							</cfif>
						</td>
						<td class="content">|</td>
						<!--- clear filter --->
						<cfif ListLen(StructKeyList(session.fb.searchForm)) GT 5>
						<td>
							<a href="javascript:void(0)" class="clearFilter">
								<img src="#session.sImageRoot#/Buttons/Default/search.png" style="vertical-align: middle;" /></a>
							<a href="javascript:void(0)" class="clearFilter">Clear Filter</a>
						</td>
						<td class="content">|</td>
						</cfif>
						<!--- filter/search responses --->
						<td>
							<a href="javascript:void(0)" class="searchForm">
								<img src="#session.sImageRoot#/Buttons/Default/search.png" style="vertical-align: middle;" /></a>
							<a href="javascript:void(0)" class="searchForm"><cfif ListLen(StructKeyList(session.fb.searchForm)) GT 5>Refine<cfelse>Filter</cfif></a>
						</td>
						<td class="content">|</td>
						<!--- export page to csv --->
						<cfif eform.pagination>
						<td>
							<a class="exportCSV" href="javascript:void;">
								<img src="#session.sImageRoot#/buttons/xls.gif" title="Export Page" style="vertical-align: middle;"></a>
							<a class="exportCSV" href="javascript:void;">Export Page</a>
						</td>															
						<cfif oPerm.bDelete>
							<td class="content">|</td>
						</cfif>
						</cfif>
						<!--- export all to csv --->
						<td>
							<a class="exportCSVall" href="javascript:void;">
								<img src="#session.sImageRoot#/buttons/xls.gif" title="Export All" style="vertical-align: middle;"></a>
							<a class="exportCSVall" href="javascript:void;">Export All</a>
						</td>															
						<cfif oPerm.bDelete>
							<td class="content">|</td>
						</cfif>
						<!--- delete options --->
						<td>
							<cfif oPerm.bDelete>
								<a class="deleteAll" href="javascript:void;">
                                    <img src="#session.sImageRoot#/Buttons/Default/boxdel.gif" style="vertical-align: middle;" /></a>
								<a class="deleteAll" href="javascript:void;">Delete All</a>
								<cfif eform.responseArchiveDays GT 0 AND isSearch>
			                        <div id="deleteOptions" style="display: none;">
										<label><input type="radio" name="rd_deleteAll" id="rd_deleteAll_all" value="all" checked="checked"> all</label>
										<label><input type="radio" name="rd_deleteAll" id="rd_deleteAll_archive" value="archive"> archived</label>
										<label><input type="radio" name="rd_deleteAll" id="rd_deleteAll_recent" value="recent"> recent</label>   
			                        </div>
								</cfif>
							</cfif>
						</td>
						<!--- search by response number --->
						<cfif eform.DisplayIDs>
							<td	style="text-align: right;">
								<table class="lightPadding headerBorder">
								<tr>
									<td class="subHeader">
										<table>
										<tr>
											<td class="subHeaderFont">Search Id:</td>
											<td><input type="text" name="txt_go_to" id="txt_go_to" value="" size="4"></td>
											<td><input type="button" class="button" id="btn_go_to" value="Go" size="4"></td>
										</tr>
										</table>
									</td>
								</tr>
								</table>
							</td>
						</cfif>
					</tr>
					</table>
					
					<!--- output response view --->
					<cfif qryResponseView.RecordCount EQ 0>
						<table class="heavyPadding">
						<tr><td colspan="2" class="info">There are no records to view for this form</td></tr>
						</table>
					<cfelse>
						<cfif NOT IsDefined("url.viewType") OR url.viewType EQ 1>
							<!--- table view --->
							<cfinclude template="includes/response_table.cfm">
						<cfelse>
							<!--- summary view --->
							<cfinclude template="includes/response_summary.cfm">
						</cfif>
						
						<cfif IsDefined("oResponses.qryUsers") AND oResponses.qryUsers.RecordCount GT 0 AND IsDefined("session.fb.searchForm.userFilter") AND session.fb.searchForm.userFilter NEQ "">
							<table class="heavyPadding">
							<tr>
								<td>
									<span class="info">Users matching the search User Filter who have not submitted a response:</span><br>
									<cfloop query="oResponses.qryUsers">
										<a href="#session.sWebRoot#/EmployeeDirectory/view_detail.cfm?userID=#oResponses.qryUsers.UserID#">#oResponses.qryUsers.FirstName# #oResponses.qryUsers.LastName#</a>
											<cfif oResponses.qryUsers.CurrentRow NEQ oResponses.qryUsers.RecordCount>,</cfif>
									</cfloop>
								</td>
							</tr>
							</table>
							
						</cfif>
					</cfif>
				</td>
			</tr>
			</table>
		</div>
	
		<devtools:site_footer />
	</cfoutput>
</cfif>