<!--- Params needed to run an update (Hotfix, Patch, or Upgrade)  --->
<cfparam name="form.Type" default="#IIf(IsDefined('url.Type'), 'url.Type', DE(''))#">
<cfparam name="form.UpdateVersion" default="#IIf(IsDefined('url.UpdateVersion'), 'url.UpdateVersion', DE(''))#">
<cfparam name="form.UpdateFile" default="#IIf(IsDefined('url.UpdateFile'), 'url.UpdateFile', DE(''))#">
<cfparam name="form.MinCF" default="#IIf(IsDefined('url.MinCF'), 'url.MinCF', DE(''))#">
<cfparam name="form.MinRailo" default="#IIf(IsDefined('url.MinRailo'), 'url.MinRailo', DE(''))#">
<cfparam name="form.MinSQL" default="#IIf(IsDefined('url.MinSQL'), 'url.MinSQL', DE(''))#">
<cfparam name="form.AdminPassword" default="#IIf(IsDefined('url.AdminPassword'), 'url.AdminPassword', DE(''))#">
<cfparam name="form.HotfixID" default="">
<cfparam name="form.Description" default="">

<!--- Unpackage any prerequisite files (if we have any and they haven't already been unpackaged) --->
<cfif NOT IsDefined("cookie.updatePrereq") AND FileExists("#application.paths.sDrive#\Updates\scripts\prereq.zip")>
	<cfzip action="unzip" 
		file="#application.paths.sDrive#\Updates\scripts\prereq.zip"
		destination="#application.paths.sDrive#" 
		overwrite="yes" />
		
	<cfset oCookie = StructNew()>
	<cfset oCookie.httponly = true>
	<cfset oCookie.secure = IIf(FindNoCase("https:", session.sWebRoot), true, false)>
	<cfset oCookie.expires = DateAdd("n", 5, Now())>
	<cfset oCookie.name = "updatePrereq">
	<cfset oCookie.value = true>
	<cfinvoke component="#application.paths.CFC#.cfcompat.bunk" method="cfcookie" argumentcollection="#oCookie#">
	
	<!--- relaunch update and blowthrough to progress --->
	<cfoutput>{"sReturnMsg":"/Admin/SiteSettings/install_update_popup.cfm?reset_app=true&Type=#form.Type#&UpdateVersion=#form.UpdateVersion#&UpdateFile=#form.UpdateFile#&MinCF=#form.MinCF#&MinSQL=#form.MinSQL#&blowthrough=true&AdminPassword=#form.AdminPassword#"}</cfoutput>
	<cfabort>
</cfif>

<!--- Include functions file (UDFs used by patch/upgrade) --->
<cfinclude template="udfs.cfm">

<!--- if this is a hotfix, we have to get the ID & description from the update.xml file --->
<cfif form.Type EQ "Hotfix">
	<cfzip action="read" 
		file="#application.paths.sDrive#\Updates\#form.UpdateFile#" 
		entrypath="update.xml" 
		variable="sUpdateInfo">
	<cfset xmlUpdate = XmlParse(sUpdateInfo)>
	<cfset form.HotfixID = ReplaceNoCase(xmlUpdate.item.title.XmlText, "Hotfix ", "")>
	<cfset form.Description = xmlUpdate.item.description.XmlText>	
	<cfset form.ReleaseDate = DateConvert("utc2Local", utcStringToDateTime(xmlUpdate.item.pubDate.XmlText))>
</cfif>

<!--- Import the current tag library for the progress bar --->
<cfimport taglib="../../cfcustomtags/devtools" prefix="devtools">

<!--- Ensure we have a long timeout --->
<cfsetting requesttimeout="60000">

<!--- Where to log update to --->
<cfset sLogFileName = "#sApplicationName#_#form.Type#_#form.UpdateVersion#">

<!--- Check CF/Railo & SQL Versions are valid --->
<cfif FindNoCase("ColdFusion", server.ColdFusion.ProductName) AND ListFirst(server.ColdFusion.ProductVersion) LT form.MinCF>
	<cfoutput>{"sReturnMsg":"errorIntranet Connections Version #form.UpdateVersion# is only compatible with a ColdFusion version of #form.MinCF# or greater.  Your current version is #application.config.CFVersion#. Please contact Intranet Connections support for instructions on how to upgrade your ColdFusion installation"}</cfoutput>
	<cfabort>
<cfelseif FindNoCase("Railo", server.ColdFusion.ProductName)
	AND (ListFirst(server.Railo.Version, ".") LT ListFirst(form.MinRailo, ".")
		OR (ListFirst(server.Railo.Version, ".") EQ ListFirst(form.MinRailo, ".")
			AND ListGetAt(server.Railo.Version, 2,  ".") LT ListGetAt(form.MinRailo, 2, ".")))>
	<cfoutput>{"sReturnMsg":"errorIntranet Connections Version #form.UpdateVersion# is only compatible with a Railo version of #form.MinRailo# or greater.  Your current version is #application.config.CFVersion#. Please contact Intranet Connections support for instructions on how to upgrade your Railo installation"}</cfoutput>
	<cfabort>		
</cfif>
<cfquery name="qrySQLInfo" datasource="#application.config.DSN#">
	SELECT CONVERT(VARCHAR(100), SERVERPROPERTY('productversion')) AS ProductVersion, 
		CONVERT(VARCHAR(100), SERVERPROPERTY ('productlevel')) AS ProductLevel, 
		CONVERT(VARCHAR(100), SERVERPROPERTY ('edition')) AS Edition
</cfquery>
<cfif ListFirst(qrySQLInfo.ProductVersion, '.') LT form.MinSQL>
	<cfoutput>{"sReturnMsg":"errorIntranet Connections Version #form.UpdateVersion# is only compatible with a SQL Server version of #form.MinSQL# or greater.  Your current version is #application.config.SQLVersion#. Please contact Intranet Connections support for instructions on how to upgrade your SQL Server installation"}</cfoutput>
	<cfabort>
</cfif>

<!--- Validate Railo admin password --->
<cfif FindNoCase("Railo", server.ColdFusion.ProductName)>
	<cfset sAction = "password">
	<cfinclude template="railo.cfm">
</cfif>

<!--- Indicate update is starting --->
<cfset sLogMessage = "Starting the #LCase(form.Type)# process">
<devtools:progress_bar_increment sMessage="#sLogMessage#">
<cflog file="#sLogFileName#" type="information" text="#sLogMessage#">
<cfthread action="sleep" duration="500" />

<cftransaction action="begin">
	<cftry>
		<!--- STEP 1: Database Schema Changes, File Migration, File Cleanup (Not applicable for hotfixes) --->
		<cfif form.Type NEQ "Hotfix">
			<cfset sLogMessage = "Updating the database schema, data, and performing migrations">
			<devtools:progress_bar_increment sMessage="#sLogMessage#">
			<cflog file="#sLogFileName#" type="information" text="#sLogMessage#">
			<cfthread action="sleep" duration="500" />
		
			<!--- run patches for current major version --->
			<cfset sCurrentMajor = ListDeleteAt(application.cache.qryAdminInfo.Version, ListLen(application.cache.qryAdminInfo.Version, "."), ".")>
			<cfset nCurrentPatch = ListLast(application.cache.qryAdminInfo.Version, ".")>
			<cfinclude template="patch.cfm">
		
			<!--- run upgrade --->
			<cfif form.Type EQ "Upgrade">
				<cfinclude template="upgrade.cfm">
				<cfset form.UpdateVersion = "12.5.0">
				<!--- run applicable patches for next major version --->
				<cfset sCurrentMajor = ListDeleteAt(form.UpdateVersion, ListLen(form.UpdateVersion, "."), ".")>
				<cfset nCurrentPatch = ListLast(form.UpdateVersion, ".")>
				<cfinclude template="patch.cfm">
			</cfif>
		</cfif>
						
		<!--- STEP 2: Update site files from ZIP package --->
		<cfset sLogMessage = "Unpackaging updated files to the intranet">
		<devtools:progress_bar_increment sMessage="#sLogMessage#">
		<cflog file="#sLogFileName#" type="information" text="#sLogMessage#">
		<cfthread action="sleep" duration="500" />
		
		<!--- get zip package from update package --->
		<cfzip action="unzip" 
			file="#application.paths.sDrive#\Updates\#form.UpdateFile#" 
			entrypath="package.zip" 
			destination="#application.paths.sDrive#\Updates" 
			overwrite="yes" />
				
		<cfif form.Type EQ "Hotfix">
			
			<!--- get a list of files that will be updated --->
			<cfzip action="list" 
				file="#application.paths.sDrive#\Updates\package.zip"
				name="qryHotfix"
				recurse="yes" />
			
			<!--- create hotfix backup location (if not already there) --->
			<cfif NOT DirectoryExists("#application.paths.sDrive#\Updates\Hotfixes")>
				<cfdirectory action="create" directory="#application.paths.sDrive#\Updates\Hotfixes">
			</cfif>
			<cfif NOT DirectoryExists("#application.paths.sDrive#\Updates\Hotfixes\#form.HotfixID#")>
				<cfdirectory action="create" directory="#application.paths.sDrive#\Updates\Hotfixes\#form.HotfixID#">
			</cfif>
			
			<!--- extract hotfix files to backup location --->
			<cfzip action="unzip" 
				file="#application.paths.sDrive#\Updates\package.zip"
				destination="#application.paths.sDrive#\Updates\Hotfixes\#form.HotfixID#\" 
				overwrite="yes" />
			
			<!--- log hot fix info --->
			<cfquery datasource="#application.config.DSN#">
				INSERT INTO	Hotfix (HotfixID, Version, DateBuilt, DateApplied, Description)
				VALUES (
					<cfqueryparam value="#form.HotfixID#" cfsqltype="cf_sql_integer">,
					<cfqueryparam cfsqltype="cf_sql_varchar" value="#form.UpdateVersion#">,
					#CreateODBCDateTime(form.ReleaseDate)#,
					GETDATE(),
					<cfqueryparam cfsqltype="cf_sql_longvarchar" value="#form.Description#">
				)
			</cfquery>
			
			<!--- log every file of hot fix and backup --->
			<cfloop query="qryHotfix">
				<cfset sFilePath = Replace(qryHotfix.name, "/", "\", "all")>
				<cfif qryHotfix.type EQ "file">
					<cfquery datasource="#application.config.DSN#">
						INSERT INTO	HotfixFile (HotfixID, FilePath)
						VALUES (
							<cfqueryparam value="#form.HotfixID#" cfsqltype="cf_sql_integer">,
							<cfqueryparam cfsqltype="cf_sql_varchar" value="#sFilePath#">
						)
					</cfquery>
					<cfif FileExists("#application.paths.sDrive#\#sFilePath#")>
						<cffile action="copy" 
							destination="#application.paths.sDrive#\Updates\Hotfixes\#form.HotfixID#\#sFilePath#" 
							source="#application.paths.sDrive#\#sFilePath#">
					<cfelse>
						<cffile action="delete" 
							file="#application.paths.sDrive#\Updates\Hotfixes\#form.HotfixID#\#sFilePath#">
					</cfif>
				</cfif>
			</cfloop>
			
			<!--- unzip updated files from package zip onto site (all will be open source and deleted by next patch/upgrade) --->
			<cfzip action="unzip" 
				file="#application.paths.sDrive#\Updates\package.zip"
				destination="#application.paths.sDrive#" 
				overwrite="yes" />
				
		<cfelseif FindNoCase("ColdFusion", server.ColdFusion.ProductName)>
				
			<!--- ********** COLDFUSION ********** --->
			
			<!--- unzip updated files from package zip onto site --->
			<cfzip action="unzip" 
				file="#application.paths.sDrive#\Updates\package.zip"
				destination="#application.paths.sDrive#" 
				overwrite="yes" />
				
			<!--- delete secure Railo archive --->
			<cfif FileExists("#application.paths.sDrive#\IntranetConnections.ras")>
				<cffile action="delete" file="#application.paths.sDrive#\IntranetConnections.ras"> 
			</cfif>
				
		<cfelse>
			
			<!--- ********** RAILO ********** --->
				
			<!--- temporarily remove secure archive mapping (so we can overwrite .ras file) --->
			<cfset sAction = "removeMapping">
			<cfinclude template="railo.cfm">
			
			<!--- unzip updated files from package zip onto site --->
			<cfzip action="unzip" 
				file="#application.paths.sDrive#\Updates\package.zip"
				destination="#application.paths.sDrive#" 
				overwrite="yes" />
				
			<!--- recreate secure archive mapping --->
			<cfset sAction = "updateMapping">
			<cfinclude template="railo.cfm">
			
			<!--- delete all cfm, cfml, cfr, cfc files (that are not open source and are part of the manifest) --->
			<cfinclude template="opensource.cfm" />
			<cfzip action="list" file="#application.paths.sDrive#\IntranetConnections.ras" name="qryManifest" recurse="yes" />
			<cfset deleteCFML(folder = application.paths.sDrive, lstOpenSource = lstOpenSource, qryManifest = qryManifest)>

		</cfif>
				
		<!--- STEP 3: Update version number in database and wipe hotfixes (patch or upgrade) --->
		<cfif form.Type NEQ "Hotfix">
			<cfset sLogMessage = "Updating the version number in the database">
			<devtools:progress_bar_increment sMessage="#sLogMessage#">
			<cflog file="#sLogFileName#" type="information" text="#sLogMessage#">
			<cfthread action="sleep" duration="500" />
			
			<cfquery datasource="#application.config.DSN#">
				DELETE FROM HotfixFile
				DELETE FROM Hotfix
			</cfquery>
			<cfquery datasource="#application.config.DSN#">
				UPDATE	Administrator_Information
				SET		Version = <cfqueryparam cfsqltype="cf_sql_varchar" value="#form.UpdateVersion#">,
						PatchDate = GETDATE()
			</cfquery>
		</cfif>
		
		<!--- STEP 4: Commit database transaction --->
		<cfset sLogMessage = "Committing database changes">
		<devtools:progress_bar_increment sMessage="#sLogMessage#">
		<cflog file="#sLogFileName#" type="information" text="#sLogMessage#">
		<cfthread action="sleep" duration="500" />
		
		<cftransaction action="commit" />
			
		<!--- STEP 5: Delete update files --->
		<cfset sLogMessage = "Deleting temporary #LCase(form.Type)# files">
		<devtools:progress_bar_increment sMessage="#sLogMessage#">
		<cflog file="#sLogFileName#" type="information" text="#sLogMessage#">
		<cfthread action="sleep" duration="500" />
					
		<cfif FileExists("#application.paths.sDrive#\Updates\#form.UpdateFile#")>
			<cffile action="delete" file="#application.paths.sDrive#\Updates\#form.UpdateFile#">
		</cfif>
		<cfif DirectoryExists("#application.paths.sDrive#\Updates\scripts\")>
			<cfdirectory action="delete" directory="#application.paths.sDrive#\Updates\scripts\" recurse="true"> 
		</cfif>
		<cfif FileExists("#application.paths.sDrive#\Updates\package.zip")>
			<cffile action="delete" file="#application.paths.sDrive#\Updates\package.zip">
		</cfif>
		<cfif form.Type NEQ "Hotfix" AND DirectoryExists("#application.paths.sDrive#\Updates\Hotfixes")>
			<cfdirectory action="delete" directory="#application.paths.sDrive#\Updates\Hotfixes" recurse="yes">
		</cfif>
		
		<!--- SUCCESS --->
		<cfset sLogMessage = "#form.Type# successfully installed. Your intranet application will now be restarted.">
		<devtools:progress_bar_increment sMessage="#sLogMessage#">
		<cflog file="#sLogFileName#" type="information" text="#sLogMessage#">
		<cfthread action="sleep" duration="500" />
		<cfoutput>{"sReturnMsg":"topAdmin/SiteSettings/site_settings.cfm?tabidx=1&reset_app=true&run_task=true"}</cfoutput>
		
		<cfcatch type="any">
			<!--- rollback any commited DB changes --->
			<cftransaction action="rollback" />			
				
			<!--- write error to the log file --->
			<cfset sErrorMessage = "Error applying #LCase(form.Type)#">
			<cfif IsDefined("cfcatch.message")>
				<cfset sErrorMessage &= ", Error: #cfcatch.message#">    
            </cfif>
            <cfif IsDefined("cfcatch.detail")>
				<cfset sErrorMessage &= ", Detail: #cfcatch.detail#">    
            </cfif>
            <cfif IsDefined("cfcatch.tagContext") AND ArrayLen(cfcatch.tagContext)>
				<cfset maxTagCount = 10>
				<cfset tagCount = 0>
				<cfloop from="1" to="#ArrayLen(cfcatch.tagContext)#" index="nIdx">
					<cfset tagCount++>
					<cfset sErrorMessage &= ", Template: #cfcatch.tagContext[nIdx].line# in #cfcatch.tagContext[nIdx].template#">
					<cfif tagCount EQ maxTagCount>
						<cfbreak>
					</cfif>
				</cfloop>
            </cfif>
            <cfif IsDefined("cfcatch.Sql")>
                <cfset sErrorMessage &= ", SQL: #cfcatch.Sql#">
            </cfif>
			<cflog file="#sLogFileName#" type="error" text="#sErrorMessage#">
			
			<!--- report error to user --->
			<devtools:progress_bar_abort sMessage="An error has occurred in the #LCase(form.Type)# script. Please check the log #sLogFileName#.log">
			<cfset sErrorMessage = 'error' & sErrorMessage>
			<cfif IsDefined("request.functions.removeJSONPrefix")>
				<cfset sErrorMessage = request.functions.removeJSONPrefix(SerializeJSON(sErrorMessage))>
			<cfelse>
				<cfset sErrorMessage = SerializeJSON(sErrorMessage)>
			</cfif>
			<cfoutput>{"sReturnMsg":#sErrorMessage#}</cfoutput>
			<cfabort>
			
			<!--- cleanup temporary update files --->
			<cfif DirectoryExists("#application.paths.sDrive#\Updates\scripts\")>
				<cfdirectory action="delete" directory="#application.paths.sDrive#\Updates\scripts\" recurse="true"> 
			</cfif>
			<cfif FileExists("#application.paths.sDrive#\Updates\package.zip")>
				<cffile action="delete" file="#application.paths.sDrive#\Updates\package.zip">
			</cfif>
			<cfif FileExists("#application.paths.sDrive#\Updates\update.xml")>
				<cffile action="delete" file="#application.paths.sDrive#\Updates\update.xml">
			</cfif>
		</cfcatch>
	</cftry>
</cftransaction>
